% Given a binary 3-way tensor, this function provides a boolean tensor 
% decomposition refined using a k-means-like updating procedure.
%
% The input are the indices of the non-zeroes of a sparse binary tensor,
% the dimensionality of the tensor, the number of clusters, the number of
% restarts of sparse_bitwise_btc (i.e. how often new centroids are selected
% at random; the k-means-like updates are only calculated once on the best
% of those results), a boolean indicating whether the centroids should be
% restricted to rank-1 (if false, this function computes k-means on the
% slices of the tensor), the number of threads to use for the calculation
% (optional, if not provided, the system default will be used)
%
% The output are the obtained centroids, the cluster assignment, and a 
% scalar indicating the similarity between the original tensor and the 
% found approximation.
% 
% See also: sparse_bitwise_btc, iterative_updates_of_btc_result