% Given a tensor T and its factorization A, B, C where C is a cluster
% assignment matrix this function computes iterative updates in a k-means 
% fashion in order to improve the result while restricting the centroids to
% have rank 1.
%
% The required input comprises the sparse tensor, i.e. a list of
% coordinates of the 1's, the three factor matrices as sparse 
% representations, the dimensionality of the tensor, the number of clusters
% (this is also one dimension of each of the factor matrices), and the
% attained similarity with the current factorization.
% 
% The output are updated centroids, a revised cluster assignment, and the 
% similarity between the original tensor and the found approximation.
%
% See also: sparse_bitwise_btc, iterative_updates
