% Given a sparse binary 3-way tensor, this function provides a boolean tensor decomposition.
% This means, it clusters the the first mode and gives a rank-1 decomposition for each
% cluster centroid. The required input comprises the sparse tensor, i.e. a list of coordinates
% of the 1's, its dimensionality, the number of clusters to find in the third mode and,
% as the cluster centroids are found by a randomized algorithm, the number of repetitions out
% of which the best solution is chosen. Optionally, the number of threads to use for the
% calculation can be specified. If not specified, the system-dependent OpenMP default number
% is used.
% The output are three binary matrices, the first two are provided as sparse, the last one of
% them being a cluster assignment matrix is dense, and a scalar indicating the similarity
% between the original tensor and the found approximation.
%
% For an input tensor X of dimensionality x*y*z and k clusters, the output will be of x*k,
% y*k and z*k. Its Khatri-Rao product again forms an x*y*z tensor X', an approximation of X.

