resdir = '../experiments/synth/';
largeData = true;
reps = 1;
iters = 5;
datadir = '../experiments/synth/data_density5percent/';
algname = 'bitwise_btc';

n = 700;
m = 500;
l = 50;

K = 3:2:15;

defD = 0.05;
defAddNoise = 0.1;
defDesNoise = 0.1;

%% K
d = defD;
dnoise = defDesNoise;
anoise = defAddNoise;

bestK = nan(iters, length(K));
L_ofBestK = nan(iters, length(K));
LE_ofBestK = nan(iters, length(K));
j = 0;

for k=K
    fprintf(2, 'k = %i ', k);
    j = j + 1; 
    for i=1:iters
        fprintf(2, '\n');
        L = nan(l+1,1);
        LE = nan(l+1,1);
        load(sprintf('%s%s_n%i_m%i_l%i_k%i_d%.2f_desNoise%.2f_addNoise%.2f_iter%i.mat', ...
            datadir, 'k', n, m, l, k, d, dnoise, anoise, i));

        parfor possK = 1:l
            fprintf(2, '%i, ', possK);
            tic
            [mA, mB, mC, sim] = sparse_bitwise_btc(T.subs, T.size, possK, reps);
            time = toc;

            %mA = double(mA);
            %mB = double(mB);
            %mC = double(mC);
            mA = spconvert([mA ones(length(mA),1); n possK 0]);
            mB = spconvert([mB ones(length(mB),1); m possK 0]);
            mC = spconvert([mC ones(length(mC),1); l possK 0]);
            
            [L(possK), LE(possK)] = dl_btc(T, mA, mB, full(mC), 'EmptyClusters', true);
        end
        [L(l+1), LE(l+1)] = dl_btc(T);
        bK = find(L == min(L));
        bestK(i,j) = bK;       
        L_ofBestK(i, j) = L(bK);
        LE_ofBestK(i, j) = LE(bK);        
    end
    fprintf(2, '\n');
    meanK = mean(bestK);
    save(sprintf('%smdl_%s.mat', resdir, algname), 'bestK', 'meanK' ,'L_ofBestK', 'LE_ofBestK');
end


